package testreflection;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.reflect.*;

public class MainFrame extends JFrame {
  JPanel contentPane;
  JTextField txtClassname = new JTextField();
  JLabel jLabel1 = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JScrollPane jScrollPane2 = new JScrollPane();
  JScrollPane jScrollPane3 = new JScrollPane();
  JList lstFields = new JList();
  JList lstConstructors = new JList();
  JList lstMethods = new JList();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  public JLabel jLabel4 = new JLabel();
  Class cls;
  JLabel jLabel5 = new JLabel();
  JTextField txtMethod = new JTextField();

  //Construct the frame
  public MainFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    txtClassname.setText("jTextField1");
    txtClassname.setBounds(new Rectangle(82, 22, 166, 23));
    txtClassname.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        txtClassname_actionPerformed(e);
      }
    });
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setSize(new Dimension(548, 342));
    this.setTitle("java reflection");
    jLabel1.setText("classname:");
    jLabel1.setBounds(new Rectangle(10, 19, 90, 26));
    jScrollPane1.setBounds(new Rectangle(254, 45, 282, 80));
    jScrollPane2.setBounds(new Rectangle(254, 142, 283, 76));
    jScrollPane3.setBounds(new Rectangle(254, 239, 283, 94));
    jLabel2.setText("fields");
    jLabel2.setBounds(new Rectangle(255, 22, 116, 20));
    jLabel3.setText("Constructors");
    jLabel3.setBounds(new Rectangle(255, 127, 113, 14));
    jLabel4.setText("methods");
    jLabel4.setBounds(new Rectangle(254, 218, 144, 18));
    jLabel5.setText("method to call:");
    jLabel5.setBounds(new Rectangle(11, 65, 87, 19));
    txtMethod.setText("jTextField1");
    txtMethod.setBounds(new Rectangle(8, 85, 237, 21));
    txtMethod.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        txtMethod_actionPerformed(e);
      }
    });
    contentPane.add(jLabel1, null);
    contentPane.add(jScrollPane2, null);
    jScrollPane2.getViewport().add(lstConstructors, null);
    contentPane.add(jScrollPane3, null);
    contentPane.add(txtClassname, null);
    contentPane.add(jScrollPane1, null);
    contentPane.add(jLabel2, null);
    contentPane.add(jLabel3, null);
    contentPane.add(jLabel4, null);
    contentPane.add(jLabel5, null);
    contentPane.add(txtMethod, null);
    jScrollPane1.getViewport().add(lstFields, null);
    jScrollPane3.getViewport().add(lstMethods, null);
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void txtClassname_actionPerformed(ActionEvent e) {
    try {
      cls = Class.forName(txtClassname.getText());
      lstConstructors.setListData(cls.getConstructors());
      lstFields.setListData(cls.getFields());
      lstMethods.setListData(cls.getMethods());
    } catch (ClassNotFoundException exc) {
      JOptionPane.showMessageDialog(this,"class not found!");
    }
  }

  void txtMethod_actionPerformed(ActionEvent e) {
    if (cls != null) {
      try {
        Object obj = cls.newInstance();
        Method m = cls.getMethod(txtMethod.getText(), null);
        m.invoke(obj,null);
      }
      catch (Exception ex) {
        JOptionPane.showMessageDialog(this,"method not found!");
      }

    }
  }

  public void hellWorld() { System.err.println("Hello World!!!"); }
}